Improve tracker deletion error message to display projects containing issues under the tracker 
Assignee: Go MAEDA % Done: 0%

Category: Administration Estimated time: 0.00 hour

Target version: 6.0.0   

Resolution: Fixed   

Description

Redmine: 1.3.3.stable.9519 (MySQL)

MySQL: 5.0.51a-24+lenny5

ruby 1.8.7 (2010-06-23 patchlevel 299) [x86_64-linux]

rails (2.3.14, 2.3.11)

As a feature, it is not possible to delete the Trackers, of existing issues.

But even after deletion of all related issues of a tracker (in all open and archived projects), it is (sometimes) not possible to delete

trackers. This is because when a project is deleted, its issues stay in the database.

A look in the Database:

- when a project is deleted of table: projects

- it's assigned issues stay in table: issues

- eg. issue 2545 has a foreign key, pointing to project 12, which was deleted

- those tickets stay around forever and can not be delete from the UI

Thus, the Tracker of issue 2545, can never be deleted, because of the "zombie" ticket.

DB-Topics: on delete cascade, referential integrity constraint

In addition, when an adminitrator trys to accesses the ticket (/issues/2545), he gets the weird message: 403 - not enough rights.

Weird, because an admin has all rights. A better message would help to find bugs faster, especially if this bugs also applies to:

versions, documents and so on.

By the way. Redmine is great, thx for your work.

Related issues:

Related to Redmine - Defect #42226: Incorrect links in tracker deletion error... Closed

Associated revisions

Revision 23181 - 2024-11-03 08:11 - Go MAEDA

Improve tracker deletion error message to display projects containing issues under the tracker (#12521).

Patch by Go MAEDA (user:maeda).

Revision 23182 - 2024-11-03 08:12 - Go MAEDA

Update locales (#12521).

Revision 23209 - 2024-11-04 05:50 - Go MAEDA

Fix project links in tracker deletion error message to set the status_id filter to "all" (#12521).

Revision 23210 - 2024-11-04 05:55 - Go MAEDA

Add missing fixture `:enumerations` to TrackersControllerTest (#12521).

Revision 23211 - 2024-11-04 05:57 - Go MAEDA

Merged r23209 and r23210 from trunk to 6.0-stable (#12521).
History

#1 - 2018-08-30 10:08 - mr gosh

This Problem is still present and affects me too.

There should be a bossibility to move all tickets with the affected tracker to another tracker or a NULL?

At least during deletion of the tracker itself.

#2 - 2019-01-10 04:43 - Marius BĂLTEANU

- Status changed from New to Closed

- Resolution set to Invalid

When you delete a project, all the related data is deleted.

mysql> select * from issues where project_id = 3;

+----+------------+------------+---------------------------------+--------------------------------------------

-----+----------+-------------+-----------+----------------+-------------+------------------+-----------+-----

---------+---------------------+---------------------+------------+------------+-----------------+-----------+

---------+------+------+------------+-----------+

| id | tracker_id | project_id | subject                         | description                                

     | due_date | category_id | status_id | assigned_to_id | priority_id | fixed_version_id | author_id | lock

_version | created_on          | updated_on          | start_date | done_ratio | estimated_hours | parent_id |

 root_id | lft  | rgt  | is_private | closed_on |

+----+------------+------------+---------------------------------+--------------------------------------------

-----+----------+-------------+-----------+----------------+-------------+------------------+-----------+-----

---------+---------------------+---------------------+------------+------------+-----------------+-----------+

---------+------+------+------------+-----------+

|  5 |          1 |          3 | Subproject issue                | This is an issue on a cookbook subproject  

     | NULL     |        NULL |         1 |           NULL |           4 |             NULL |         2 |     

       0 | 2018-12-19 18:54:11 | 2018-12-22 18:54:11 | NULL       |          0 |            NULL |      NULL |

       5 |    1 |    2 |          0 | NULL      |

| 13 |          1 |          3 | Subproject issue two            | This is a second issue on a cookbook subpro

ject | NULL     |        NULL |         1 |           NULL |           4 |             NULL |         2 |     

       0 | 2018-12-19 18:54:11 | 2018-12-22 18:54:11 | NULL       |          0 |            NULL |      NULL |

      13 |    1 |    2 |          0 | NULL      |

| 14 |          1 |          3 | Private issue on public project | This is a private issue                    

     | NULL     |        NULL |         1 |           NULL |           5 |             NULL |         2 |     

       0 | 2018-12-09 18:54:11 | 2018-12-09 18:54:11 | NULL       |          0 |            NULL |      NULL |

      14 |    1 |    2 |          1 | NULL      |

| 15 |          3 |          3 | Private issue on public project | This is a private issue                    

     | NULL     |        NULL |         2 |           NULL |           5 |             NULL |         1 |     

       0 | 2019-01-10 03:20:53 | 2019-01-10 03:20:53 | 2019-01-10 |          0 |            NULL |      NULL |

      15 |    1 |    2 |          1 | NULL      |

+----+------------+------------+---------------------------------+--------------------------------------------

-----+----------+-------------+-----------+----------------+-------------+------------------+-----------+-----

---------+---------------------+---------------------+------------+------------+-----------------+-----------+

---------+------+------+------------+-----------+

4 rows in set (0.00 sec)

 Deleted the project with id 3 from UI, Administration -> Projects

mysql> select * from issues where project_id = 3;

Empty set (0.00 sec)

 mr gosh wrote:

There should be a bossibility to move all tickets with the affected tracker to another tracker or a NULL?

At least during deletion of the tracker itself.

 You already have this possibility, you can open the Issue global page, filter issues only by the tracker that you want to delete and using bulk edit,

change tracker type to another.

#3 - 2019-01-15 14:38 - mr gosh

Marius BALTEANU wrote:

You already have this possibility, you can open the Issue global page, filter issues only by the tracker that you want to delete and using bulk edit,

change tracker type to another.

 You're right - but this is not possible if you have closed or archived projects - but this can be achieved by re-opening these projects - perhaps we

reconsider our "projects don't get deleted" philosophy at this point. ;)
#4 - 2019-01-18 08:24 - Marius BĂLTEANU

- Tracker changed from Defect to Feature

- Subject changed from Tracker can not be deleted - because issues of deleted projects stay in the database to Tracker can not be deleted - because

issues of archived projects cannot be found without unarchiving the projects

- Category changed from Database to Issues filter

- Status changed from Closed to Reopened

- Resolution deleted (Invalid)

mr gosh wrote:

You're right - but this is not possible if you have closed or archived projects - but this can be achieved by re-opening these projects - perhaps we

reconsider our "projects don't get deleted" philosophy at this point. ;)

 It is possible when you have closed projects because you can filter issues by "Project's status" (feature available in Redmine 4.0.0, please see 

#20081), but indeed, for archived projects, you can't and on instances with a lot of archived projects, it could be quite a challenge.

I'm reopening this ticket as s Feature, maybe we can find a solution to help users delete trackers used by issues from archived projects. As a first

idea, what do you think if we add to the error message the archived projects that have issues with that tracker?

#5 - 2019-01-18 08:25 - Marius BĂLTEANU

- Category changed from Issues filter to Administration

#6 - 2024-02-01 08:15 - Go MAEDA

- File 12521.patch added

- File clipboard-202402011612-0szhs.png added

- File clipboard-202402011614-wa20u.png added

Marius BĂLTEANU wrote in #note-4:

I'm reopening this ticket as s Feature, maybe we can find a solution to help users delete trackers used by issues from archived projects. As a

first idea, what do you think if we add to the error message the archived projects that have issues with that tracker?

 The attached patch 12521.patch implements similar feature. When tracker cannot be deleted, it displays links to all projects including archived ones

which have issues with the tracker.

Althgouh an error page is displayed if you click a link to an archived project, you can unarchive the project by clicking a button in the error page.

 clipboard-202402011612-0szhs.png 

 clipboard-202402011614-wa20u.png 

#7 - 2024-02-01 16:50 - Marius BĂLTEANU

I think the patch has an error projects = Project.joins(:issues).where(issues: { tracker_id: 1 }).distinct because tracker_id is hardcoded to 1.

#8 - 2024-02-02 06:39 - Go MAEDA

- File 12521-v2.patch added

Marius BĂLTEANU wrote in #note-7:

I think the patch has an error projects = Project.joins(:issues).where(issues: { tracker_id: 1 }).distinct because tracker_id is hardcoded to 1.

 Sorry, I made a trivial mistake. Here is an updated patch with a test.

#9 - 2024-02-07 02:49 - Go MAEDA

- Target version set to Candidate for next major release

#10 - 2024-05-28 11:00 - Go MAEDA

- Target version changed from Candidate for next major release to 6.0.0

Setting the target version to 6.0.0.
#11 - 2024-05-28 15:23 - Holger Just

The patch in 12521-v2.patch looks fine to me, thanks!

I'd just propose to update the generated project links to set the status_id filter to "all" so that even closed issues are displayed there. This could look

like:

# ...

view_context.link_to(p, project_issues_path(p, set_filter: 1, tracker_id: @tracker.id, status_id: '*'))

# ...

#12 - 2024-10-08 11:51 - Go MAEDA

- File 12521-v3.patch added

Holger Just wrote in #note-11:

I'd just propose to update the generated project links to set the status_id filter to "all" so that even closed issues are displayed there. This could

look like:

[...]

 Thank you for checking the patch, I have changed the code accordingly.

#13 - 2024-11-03 08:15 - Go MAEDA

- Subject changed from Tracker can not be deleted - because issues of archived projects cannot be found without unarchiving the projects to Improve

tracker deletion error message to display projects containing issues under the tracker 

- Status changed from Reopened to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

I have committed the patch in r23181.

The tracker deletion error message now displays a list of projects that contain issues under the tracker. See the screenshots in #note-6.

#14 - 2025-02-05 16:10 - Go MAEDA

- Related to Defect #42226: Incorrect links in tracker deletion error message for projects where tracker is disabled added

Files

12521.patch 1.76 KB 2024-02-01 Go MAEDA

clipboard-202402011612-0szhs.png 113 KB 2024-02-01 Go MAEDA

clipboard-202402011614-wa20u.png 56.9 KB 2024-02-01 Go MAEDA

12521-v2.patch 2.8 KB 2024-02-02 Go MAEDA

12521-v3.patch 2.81 KB 2024-10-08 Go MAEDA
